#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include <ctype.h>
#include <string.h>
#include <fstream.h>

enum bool { false, true };

bool finish = false;
long caseNo = 0;
const long MAX = 110;
const long LEN = 210;
long N, M;

void Space(long n){
	for (long i = 0; i < n; i++)
		cout << ' ';
}

struct Col{
	bool ended;
	long cnt;
	long len;
	long cur;
	char data[LEN];
	void Print(bool);
} col[MAX];

void Col :: Print(bool space){
	long l = 0;
	if (!ended){
		for (;data[cur] != ','; cur++, l++)
			cout << data[cur];
		cur++;
	}
	if (cur == strlen(data))
		ended = true;
	if (space)
		Space(len - l + 1);
}

void Input()
{
	char st[LEN];
	N = 0;
	while(cin >> st, !cin.eof() || st[0]){
		long l = strlen(st);
		st[l] = ',';
		st[l+1] = 0;
		strcpy(col[N++].data, st);
	}
	for (long n = 0; n < N; n++){
		col[n].ended = false;
		long i = 0, j = 0;
		while (i < strlen(col[n].data)){
			j = i;
			while(col[n].data[j] != ',')
				j++;
			if (j - i > col[n].len)
				col[n].len = j - i;
			i = j + 1;
			col[n].cnt++;
		}
	}
	M = 0;
	for(long i = 0; i < N; i++)
		if (M < col[i].cnt)
			M = col[i].cnt;
}

void Solve(){
	for (long n = 0; n < M; n++){
		for (long i = 0; i < N; i++){
			bool space = false;
			for (long j = i + 1; j < N; j++)
				if (!col[j].ended){
					space = true;
					break;
				}
			col[i].Print(space);
		}
		cout << endl;
	}
}

void Output(){
}


int main()
{
	ifstream is = "input.txt";
	ofstream os = "output.txt";
	cin = is;
	cout = os;

		Input();
		Solve();
		Output();

	return 0;
}