const ArrDiv=3;
      ArrMod=10001;
type TPair=record
       N:integer;
       s:longint;
       end;
     PArr=^TArr;
     TArr=array[0..ArrMod-1] of TPair;
var Arr:array[0..ArrDiv-1] of PArr;
var M:longint;

function GetCS(n:integer):longint;
begin
GetCS:=Arr[N div ArrMod]^[n mod ArrMod].s;
end;

function GetCN(n:integer):integer;
begin
GetCN:=Arr[N div ArrMod]^[n mod ArrMod].n;
end;

procedure PutC(n:integer; c:TPair);
begin
Arr[N div ArrMod]^[N mod ArrMod]:=c;
end;

function IsLess(s:longint;n:integer;c2:TPair):boolean;
begin
IsLess:=(s<c2.s) or ((s=c2.s) and (n<c2.n));
end;

function IsMore(s:longint;n:integer;c2:TPair):boolean;
begin
IsMore:=(s>c2.s) or ((s=c2.s) and (n>c2.n));
end;

procedure PutC2(i:integer; s:longint; n:integer);
var temp:TPair;
begin
Temp.s:=s; Temp.n:=n;
PutC(i,Temp);
end;

var x,temp:TPair;

procedure QSort(l,r:integer);
var i,j:integer;
begin
if r>l then
  begin
  i:=l;
  j:=r;
  x.s:=GetCS((l+r) div 2);
  x.n:=GetCN((l+r) div 2);

  while i<=j do
    begin
    while IsLess(GetCS(i),GetCN(i),x) do
      inc(i);
    while IsMore(GetCS(j),GetCN(j),x) do
      dec(j);
    if i<=j then
      begin
      temp.s:=GetCS(i);
      temp.n:=GetCN(i);
      PutC2(i,GetCS(j),GetCN(j));
      PutC(j,temp);
      inc(i);
      dec(j);
      end;
    if j>l then
      QSort(l,j);
    if i<r then
      QSort(i,r);
    end;
  end;
end;

var i,k:integer;
    a:longint;
    s1:longint;
    s:longint;
    BestLen,BestF:longint;
begin
assign(input,'input.txt');
assign(output,'output.txt');
reset(input);
rewrite(output);

for i:=0 to ArrDiv-1 do
  new(Arr[i]);

readln(M,s);
s1:=0;
PutC2(0,0,0);
for i:=1 to m do
  begin
  readln(a);
  s1:=s1+a;
  PutC2(i,s1,i);
  end;

QSort(0,M);
BestLen:=0;
K:=M-1;
for i:=M downto 0 do
  begin
  if GetCS(i)-GetCS(k)=s then
    if (BestLen<=GetCN(i)-GetCN(k)) and (GetCN(i)-GetCN(k)>0) then
      begin
      BestLen:=GetCN(i)-GetCN(k);
      BestF:=GetCN(k)+1;
      end;
  while (k>0) and (GetCS(i)-GetCS(k-1)<=s) do
    begin
    dec(k);
    if GetCS(i)-GetCS(k)=s then
      if (BestLen<=GetCN(i)-GetCN(k)) and (GetCN(i)-GetCN(k)>0) then
        begin
        BestLen:=GetCN(i)-GetCN(k);
        BestF:=GetCN(k)+1;
        end;
    end;
  end;

if BestLen=0 then
  writeln('0 0')
else
  writeln(BestF,' ',BestLen);

for i:=0 to ArrDiv-1 do
  dispose(Arr[i]);

close(input);
close(output);
end.