#include <fstream.h>
typedef unsigned int uint;
struct str
{
  long s;
  int i;
};
const int mmax = 30000;
const uint mask = 0xFFFF;
uint *sh, *sl;
int *in;
int a[mmax + 1];
int less1(int i, str a)
{
  long s;
  s = (long)sh[i] << 16 | sl[i];
  return s < a.s || s == a.s && in[i] < a.i;
}
int less2(str a, int i)
{
  long s;
  s = (long)sh[i] << 16 | sl[i];
  return a.s < s || a.s == s && a.i < in[i];
}
void sort(int l, int r)
{
  long i, j, m;
  str x;
  long t;
  if (l < r)
  {
    m = (l + r) / 2;
    i = l; j = r; x.s = (long)sh[m] << 16 | sl[m]; x.i = in[m];
    do
    {
      for (; less1(i, x); i++);
      for (; less2(x, j); j--);
      if (i <= j)
      {
	t = sh[i]; sh[i] = sh[j]; sh[j] = t;
	t = sl[i]; sl[i] = sl[j]; sl[j] = t;
	t = in[i]; in[i] = in[j]; in[j] = t;
	i++; j--;
      }
    }
    while (i <= j);
    sort(l, j);
    sort(i, r);
  }
}
main()
{
  long m, s, t;
  long i, l, r, ml, mi, med;
  long sum;
  str st;
  ifstream is("input.txt");
  ofstream os("output.txt");
  cin = is;
  cout = os;
  cin >> m >> sum;
  for (i = 1; i <= m; i++)
  {
    cin >> a[i];
  }
  a[0] = 0;
  s = 0;
  sh = new uint[m];
  sl = new uint[m];
  in = new int[m];
  for (i = 0; i < m; i++)
  {
    s += a[i];
    sh[i] = s >> 16;
    sl[i] = s & mask;
    in[i] = i;
  }
  sort(0, m - 1);
/*
  for (i = 0; i < m; i++)
  {
    cout << ((long)sh[i] << 16 | sl[i]) << " " << in[i] << endl;
  }
*/
  ml = 0;
  mi = -1;
  s = 0;
  for (i = 1; i <= m; i++)
  {
    s += a[i];
    l = 0; r = m - 1;
    st.s = s - sum;
    st.i = i - 1;
    while (l < r)
    {
      med = (l + r) / 2;
      t = (long)sh[med] << 16 | sl[med];
      if (t < st.s)
      {
	l = med + 1;
      }
      else
      {
	if (t > st.s)
	{
	  r = med;
	}
	else
	{
	  r = med;
	}
      }
    }
    if (l == r && ((long)sh[l] << 16 | sl[l]) == st.s && in[l] < i && (i - in[l] > ml || i - in[l] == ml && in[l] < mi))
    {
      ml = i - in[l];
      mi = in[l];
    }
  }
  cout << mi + 1 << " " << ml << endl;
  delete sh; delete sl; delete in;
  return 0;
}
