type
  TPoint = record
    x,y:byte;
  end;

const
  infile = 'input.txt';
  outfile = 'output.txt';

var
  fi, fo : text;
  pole:array[1..8,1..8] of byte;
  i,x,y:integer;
  ch:char;
  myhod,hod:array[1..33] of TPoint;

function cando(fx,fy,tx,ty:byte):boolean;
begin
  if pole[fx,fy]<>0 then begin
    cando:=false;
    exit;
  end;
  cando:=true;
  if (fx=tx) or (fy=ty) then exit;
  if abs(fx-tx)=abs(fy-ty) then exit;
  cando:=false;
end;

function next(step:byte):boolean;
var
  dx,dy,i, x, y,nx,ny:shortint;
begin
  if step=33 then begin
    next:=true;
    exit;
  end;
  x:=hod[step].x;
  y:=hod[step].y;
  for dx:=1 downto -1 do
    for dy:=1 downto -1 do begin
      if not((dx=0) and (dy=0)) then begin
        i:=1;
        nx:=x+dx*i;
        ny:=y+dy*i;
        while (nx>0) and (nx<9) and (ny>0) and (ny<9) do begin
{          if step=32 then begin
            if (pole[nx,ny]=0) and (then begin
                next:=true;
                myhod[step].x:=nx;
                myhod[step].y:=ny;
                exit;
            end;
          end else begin }
            if cando(nx,ny,hod[step+1].x,hod[step+1].y) then begin
              pole[nx,ny]:=1;
              if next(step+1) then begin
                myhod[step].x:=nx;
                myhod[step].y:=ny;
                next:=true;
                exit;
              end
              else pole[nx,ny]:=0;
            end;
          {end;}
          inc(i);
          nx:=nx+dx{x+dx*i};
          ny:=ny+dy{y+dy*i};
        end;
      end;
    end;
  next:=false;
end;

procedure print;
var
  i:integer;
begin
  for i:=1 to 32 do begin
    write(fo,chr(myhod[i].x+96),myhod[i].y);
    if i<>32 then write(fo,' ');
  end;
end;

begin
  assign(fi, infile); assign(fo, outfile);
  reset(fi); rewrite(fo);

  for x:=1 to 8 do
    for y:=1 to 8 do
      pole[x,y]:=0;

  for i:=1 to 32 do begin
    read(fi,ch);
    x:=ord(upcase(ch))-64;
    read(fi,ch);
    y:=ord(ch)-48;
    read(fi,ch);
    hod[i].x:=x;
    hod[i].y:=y;
    pole[x,y]:=2;
  end;
  hod[33]:=hod[1];

  next(1);
  print;
  close(fi); close(fo);
end.