#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include <math.h>

FILE *fin,*fout;
/*
struct sss{
	long sum;
	int index;
};
sss huge mass[30016];
*/

long huge mass_sum[32768];
long huge mss[32768];
int huge mass_index[32768];


int i, tmp, ti;
long max_F, max_L;
int M;
long S;
long cur_L, cur_F ;


void q_sort(int l, int r);
int find_s(long d, int pos);

int main(void){
	fin=fopen("input.txt","rt");
	fout=fopen("output.txt","wt");

	for (i=0; i<30016; i++) {
		mass_sum[i] = 0;
		mass_index[i] = 0;
	}

	fscanf(fin, "%d %d\n", &M, &S);
	fscanf(fin, "%d\n", &tmp);
	mass_index[0] = 0;
	mass_sum[0] = tmp;
	for (i=1; i<M; i++) {
		fscanf(fin, "%d\n", &tmp);
		mass_index[i] = i;
		ti = i-1;
		mass_sum[i] = mass_sum[ti] + tmp;
		mss[i] = mass_sum[i];
	}
	max_L = 0; max_F = 0;
	if (mass_sum[0] == S) {
		max_L = 1;
		max_F = 0;
	}

	q_sort(0, M-1);
//!!!!!!!
	for(i=1; i<M; i++) {
		long d = mss[i] - S;
		if (d==0) {
			cur_F = 0;
			cur_L = i+1;
			if (cur_L > max_L) {
				max_L = cur_L;
				max_F = cur_F;
			}

		}else{
			int index;
			index = find_s(d, i-1);
			if (index >= 0) {
				cur_F = index + 1;
				cur_L = i - index;
				if (cur_L > max_L) {
					max_L = cur_L;
					max_F = cur_F;
				}
			}
		}
	}
	max_F++;
	if (max_L==0) {
		max_F=0;
	}
	fprintf(fout, "%ld %ld\n", max_F, max_L);
	fcloseall();
	return 0;
}

int find_s(long d, int pos) {
	int l=0, r=M;
	long w;
	int ttt;
	while(l!=r) {
		ttt=(l+r)/2;
		w=mass_sum[ttt];
		if (d<=w)
			r = ttt;
		if (d>w)
			l = ttt+1;
	}
	if (mass_sum[l] == d) {
		while(1) {
			if (l>0) {
				int ll = l-1;
				if(mass_sum[ll] == d)
					l--;
				else
					break;
			}else
				break;
		}
		while(1) {
			if(mass_index[l] >= pos)
				l++;
			else
				break;
			if(l>=M)
				break;
		}
		if(l<M && mass_sum[l] == d)
			return mass_index[l];
		else
			return -1;

	}else
		return -1;
}

int t_cmp(int i, int index, long sum) {
	if (mass_sum[i] > sum)
		return 1;
	if (mass_sum[i] < sum)
		return -1;
	if (mass_index[i] > index)
		return 1;
	if (mass_index[i] < index)
		return -1;
	return 0;

}

void q_sort(int l, int r) {
	int i=l, j=r, w;
	long sum;
	int index;
	w = (l+r)/2;
	long x = mass_sum[w];
	int ii = mass_index[w];
	while (i<=j) {
		while( t_cmp(i, ii, x)==-1) i++;
		while( t_cmp(j, ii, x)== 1) j--;
		if (i<=j) {
			index = mass_index[i];
			sum = mass_sum[i];
			mass_index[i] = mass_index[j];
			mass_sum[i] = mass_sum[j];
			mass_index[j] = index;
			mass_sum[j] = sum;
			i++;
			j--;
		}
	}
	if(l<j) q_sort(l, j);
	if(i<r) q_sort(i, r);
}


