#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include <math.h>

FILE *fin,*fout;
int N, M;
char pole[204][204];
char tmp[210];
int huge x[50000L];
int huge y[50000L];
long qa, qb;
long col;
int dx[] = { 0, 1, 0,-1};
int dy[] = {-1, 0, 1, 0};
int i;
int j;

long wave();

int main(void){
	fin=fopen("input.txt","rt");
	fout=fopen("output.txt","wt");

	for (i=0; i<204; i++)
		for(j=0; j<204; j++)
			pole[i][j] = '.';


	fscanf(fin, "%d %d\n", &N, &M);
	for (i=0; i<N; i++) {
		tmp[0]=0;
		fscanf(fin, "%s", tmp);
		strcpy(pole[i], tmp);
	}
	long t_out = wave();
	fprintf(fout, "%ld\n", t_out);
	fcloseall();
	return 0;
}

long wave() {
	int xt, yt, xxx, yyy;
	int x_next, y_next;
	int ooo;
	qa=1; qb=0;
	x[0] = 0; y[0]=0;
	col=0;
	while (qa!=qb) {
		xt = x[qb];
		yt = y[qb];
		qb = (qb+1)%50000L;
		for (i=0; i<4; i++) {
			x_next = xt + dx[i];
			y_next = yt + dy[i];

			if (x_next < 0 || x_next >= M) continue;
			if (y_next < 0 || y_next >= N) continue;

			if (pole[y_next][x_next] == '.') {
				x[qa] = x_next;
				y[qa] = y_next;
				qa = (qa+1)%50000L;
				pole[y_next][x_next] = 2;
			}
			if (pole[y_next][x_next] == '*') {
				col++;
		/*		ooo = 0;
				for (int jj=0; jj<4; jj++) {
					xxx = x_next + dx[jj];
					yyy = y_next + dy[jj];
					if(pole[yyy][xxx] == '*' || pole[yyy][xxx] == 3)
						ooo=1;
				}
				if (ooo==0)
					col--;*/

				pole[y_next][x_next] = 3;
			}
		}
	}
	return col;
}
