#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include <ctype.h>
#include <string.h>
#include <fstream.h>

enum bool { false, true };

bool finish = false;
long caseNo = 0;

long L[164][2];
long my_L[164][2];
short moves[164][2];
short my_moves[164][2];
long step, step2, step_count;
long A[8][8];
long C[8][8];

void Input()
{
	char c1, c2;
	step_count = 0;
	memset(C, 0, sizeof C);
	for (;;)
		{
			if (cin.eof())
				break;
			cin >> c1 >> c2;

			moves[step_count][1] = c1 - 'a';
			moves[step_count][0] = c2 - '1';
			C[moves[step_count][0]][moves[step_count][1]] = 1;
			step_count++;

			cin.ignore();
		}

}

long R(long deep) {
	long r = moves[deep][0];
	long c = moves[deep][1];
	A[r][c] = 1;

	if ((deep + 1) < step_count)
		{
			long x1 = L[deep][0] & L[deep + 1][0];
			long x2 = L[deep][1] & L[deep + 1][1];

			if (x1 == 0 && x2 == 0)
				return 0;

			for (long k = 0; k < 32; k++)
				if ((x1 >> k) & (long)1)
				if (!A[k / 8][k % 8] && !C[k / 8][k % 8])
				{
					A[k / 8][k % 8] = 1;
					if (R(deep + 1))
						{
							my_moves[deep][0] = k / 8;
							my_moves[deep][1] = k % 8;

							return 1;
						}
					A[k / 8][k % 8] = 0;
				}
			for (k = 0; k < 32; k++)
				if ((x2 >> k) & (long)1)
				if (!A[(k / 8) + 3][k % 8] && !C[(k / 8) + 3][k % 8])
				{
					A[3 + (k / 8)][k % 8] = 1;
					if (R(deep + 1))
						{
							my_moves[deep][0] = (k / 8) + 3;
							my_moves[deep][1] = k % 8;

							return 1;
						}
					A[(k / 8) + 3][k % 8] = 0;
				}

		}
	else
		{
			long x1 = L[deep][0] & L[deep + 1][0];
			long x2 = L[deep][1] & L[deep + 1][1];

			if (x1 || x2)
				return 1;
			else
				return 0;

		}
	A[r][c] = 0;

	return 0;
}

void Solve()
{
	step = 0;
	long B[8][8];

	memset(L, 0, sizeof L);
	memset(B, 1, sizeof B);

	for (long k = 0; k < step_count; k++)
		{
			for (long i = 0; i < 8; i++)
				for (long j = 0; j < 8; j++)
					if ((i == moves[k][0] ||
						 j == moves[k][1] ||
						 abs(i - moves[k][0]) == abs(j - moves[k][1])) &&
						 B[i][j])
							L[k][i > 3] |= (long)1 << (long)((i % 4) * 8 + j);

			B[moves[k][0]][moves[k][1]] = 0;
		}

	memset(my_moves, 0, sizeof my_moves);

	R(0);
}

void Output()
{
	for (long i = 0; i < step_count; i++)
		cout << (char)(my_moves[i][0] + 'a') << (char)(my_moves[i][0] + '1') << ' ';
}


int main()
{
	ifstream is = "input.txt";
	ofstream os = "output.txt";
	cin = is;
	cout = os;

		Input();
		Solve();
		Output();

	return 0;
}