#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <values.h>

#pragma option -v-

typedef unsigned long ulong;
typedef unsigned int uint;

#define max(a,b) (a>b?a:b)
#define min(a,b) (a<b?a:b)

char T[200][202];
int N, M, isw;
long R;

int inline dow(int i, int j) {
	if (i<0 || j<0 || i>=N || j>=M) return 0;
	if (T[i][j]>'.') return 0;
	if (T[i][j]=='.') {
		T[i][j] = 47;
		isw = 1;
		return 1;
	} else T[i][j] = '1';
}

void wave() {
	do {
	isw = 0;
	for (int i=0; i<N; i++) {
		for(int j=0; j<M; j++) {
			if (T[i][j]==47) {
				dow(i,j+1);
				int a = dow(i,j-1);
				dow(i+1,j);
				int b = dow(i-1,j);
				T[i][j]='2';
				if (a) j-=2;
				if (b) i-=2;
			}
		}
	}
	} while (isw);
}

int main() {
	FILE *fi = fopen("input.txt", "r");
	fscanf(fi, "%d %d\n", &N, &M);
	int i;
	for (i=0; i<N; i++) {
		fscanf(fi, "%s", T[i]);
	}
	fclose(fi);
	T[0][0] = 47;
	wave();

	R=0;
	for (i=0; i<N; i++) {
		for (int j=0; j<M; j++) {
			if (T[i][j]=='1') R++;
		}
	}

	FILE *fo = fopen("output.txt", "w");
	fprintf(fo, "%ld\n", R);
	fclose(fo);
	return 0;
}